package com.jy.system.service.impl;

import com.baomidou.mybatisplus.core.toolkit.StringPool;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jy.framework.model.constants.RedisConstant;
import com.jy.framework.redis.RedisCache;
import com.jy.framework.redis.RedisKey;
import com.jy.framework.utils.AssertUtil;
import com.jy.system.dao.SysConfigDao;
import com.jy.system.model.dto.SysConfigDto;
import com.jy.system.model.dto.SysConfigSelectDto;
import com.jy.system.model.entity.SysConfig;
import com.jy.system.model.vo.SysConfigVo;
import com.jy.system.service.SysConfigService;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 * 全局配置 服务实现类
 * </p>
 *
 * @author
 * @since 2024-06-20
 */
@Service
public class SysConfigServiceImpl implements SysConfigService {

    @Resource
    private SysConfigDao sysConfigDao;

    @Override
    public Page<SysConfigVo> getPage(SysConfigSelectDto dto) {
        return sysConfigDao.getPage(dto);
    }

    @Override
    public SysConfigVo getDetail(Long id) {
        SysConfigVo vo = sysConfigDao.getDetail(id);
        AssertUtil.notNull(vo, "未知数据");
        return vo;
    }

    @Override
    public void add(SysConfigDto dto) {
        // 验证配置key是否存在
        boolean codeExists = sysConfigDao.codeExists(dto.getCode());
        AssertUtil.eqFalse(codeExists, "参数键名已存在");

        // 保存配置信息
        sysConfigDao.save(dto);
    }

    @Override
    public void edit(SysConfigDto dto) {
        // 查询原数据
        SysConfig sysConfig = sysConfigDao.getById(dto.getId());
        AssertUtil.notNull(sysConfig, "未知数据");

        // 验证配置key是否存在
        boolean codeExists = sysConfigDao.codeExists(dto.getCode(), dto.getId());
        AssertUtil.eqFalse(codeExists, "参数键名已存在");

        // 删除配置缓存
        RedisCache.delete(RedisKey.getConfig(sysConfig.getCode()));

        // 更新配置信息
        sysConfigDao.updateById(dto);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<Long> idList) {
        // 删除配置缓存
        List<SysConfig> sysConfigList = sysConfigDao.listByIds(idList);
        sysConfigList.forEach(item -> RedisCache.delete(RedisKey.getConfig(item.getCode())));

        // 删除配置信息
        sysConfigDao.removeBatchByIds(idList);
    }

    @Override
    public void refreshCache() {
        List<String> scan = RedisCache.scan(RedisConstant.CONFIG_KEY + StringPool.ASTERISK);
        scan.forEach(RedisCache::delete);
    }

}
